| Methods |
abstract
public
|
duration(): DateInterval
Duration of one occurrence.
Duration of one occurrence.
Implemented by
|
#
|
public
|
end(): ?DateTimeValue
End of the (first) occurrence.
End of the (first) occurrence.
Overridden by
|
#
|
public
|
property(string $name): ?Property
|
#
|
public
|
properties(string $name): list<Property>
|
#
|
public
|
value(string $name): mixed
Typed value of the first property with the name, see ValueParser::value().
Typed value of the first property with the name, see ValueParser::value().
|
#
|
public
|
calendar(): Calendar
|
#
|
public
|
uid(): ?string
|
#
|
public
|
summary(): ?string
|
#
|
public
|
description(): ?string
|
#
|
public
|
location(): ?string
LOCATION text; see locations() for VLOCATION components.
LOCATION text; see locations() for VLOCATION components.
|
#
|
public
|
locations(): list<Location>
VLOCATION components (RFC 9073).
VLOCATION components (RFC 9073).
|
#
|
public
|
status(): ?string
STATUS in upper case, e.g. CONFIRMED, TENTATIVE, CANCELLED, NEEDS-ACTION, COMPLETED.
STATUS in upper case, e.g. CONFIRMED, TENTATIVE, CANCELLED, NEEDS-ACTION, COMPLETED.
|
#
|
public
|
isCancelled(): bool
|
#
|
public
|
classification(): string
CLASS: PUBLIC (default), PRIVATE or CONFIDENTIAL.
CLASS: PUBLIC (default), PRIVATE or CONFIDENTIAL.
|
#
|
public
|
url(): ?string
|
#
|
public
|
sequence(): int
|
#
|
public
|
priority(): ?int
|
#
|
public
|
categories(): list<string>
|
#
|
public
|
color(): ?string
COLOR (RFC 7986): a CSS3 color name.
COLOR (RFC 7986): a CSS3 color name.
|
#
|
public
|
images(): list<Image>
IMAGE properties (RFC 7986); images with invalid binary data are skipped.
IMAGE properties (RFC 7986); images with invalid binary data are skipped.
|
#
|
public
|
conferences(): list<Conference>
CONFERENCE properties (RFC 7986).
CONFERENCE properties (RFC 7986).
|
#
|
public
|
links(): list<Link>
LINK properties (RFC 9253).
LINK properties (RFC 9253).
|
#
|
public
|
relatedTo(): list<Relation>
RELATED-TO properties with the relation types and GAP of RFC 9253.
RELATED-TO properties with the relation types and GAP of RFC 9253.
|
#
|
public
|
created(): ?DateTimeValue
|
#
|
public
|
lastModified(): ?DateTimeValue
|
#
|
public
|
stamp(): ?DateTimeValue
|
#
|
public
|
organizer(): ?CalAddress
|
#
|
public
|
attendees(): list<CalAddress>
|
#
|
public
|
start(): ?DateTimeValue
|
#
|
public
|
isAllDay(): bool
|
#
|
public
|
alarms(): list<Alarm>
|
#
|
public
|
recurrenceRule(): ?Rule
|
#
|
public
|
recurrenceRules(): list<Rule>
All valid RRULE properties; several rules are combined (RFC 2445 allowed that).
All valid RRULE properties; several rules are combined (RFC 2445 allowed that).
|
#
|
public
|
recurrenceDates(): list<DateTimeValue>
|
#
|
public
|
exceptionDates(): list<DateTimeValue>
|
#
|
public
|
isRecurring(): bool
|
#
|
public
|
recurrenceId(): ?DateTimeValue
|
#
|
public
|
isOverride(): bool
True for a component modifying an instance of a recurring item (it has a RECURRENCE-ID).
True for a component modifying an instance of a recurring item (it has a RECURRENCE-ID).
|
#
|
public
|
isThisAndFuture(): bool
RANGE=THISANDFUTURE: the override applies to its instance and all later ones.
RANGE=THISANDFUTURE: the override applies to its instance and all later ones.
|
#
|
public
|
overrides(): list<Item>
Components modifying instances of this recurring item.
Components modifying instances of this recurring item.
|
#
|
public
|
occurrencesBetween(
DateTimeInterface $from,
DateTimeInterface $to,
bool $includeCancelled = false,
): Generator<int, Occurrence>
Occurrences overlapping [$from, $to), in chronological order. Dates and floating times are compared with the local time of $from and $to.
Cancelled instances (STATUS:CANCELLED overrides) are skipped unless requested.
Occurrences overlapping [$from, $to), in chronological order. Dates and floating times are compared with the local time of $from and $to.
Cancelled instances (STATUS:CANCELLED overrides) are skipped unless requested.
|
#
|
public
|
occurrences(
int $limit = 1000,
?DateTimeInterface $from = null,
bool $includeCancelled = false,
): Generator<int, Occurrence>
The first occurrences, optionally from the given moment.
The first occurrences, optionally from the given moment.
|
#
|
protected
|
remember<T>(string $key, callable(): T $calculate): T
|
#
|
protected
|
has(string $name): bool
|
#
|
protected
|
text(string $name): ?string
|
#
|
protected
|
integer(string $name): ?int
|
#
|
protected
|
date(string $name): ?DateTimeValue
|
#
|
protected
|
dates(string $name): list<DateTimeValue>
|
#
|
protected
static
|
between(DateTimeValue $start, DateTimeValue $end): DateInterval
Duration from DTSTART to DTEND (or DUE): the exact elapsed time for UTC and zoned values,
the wall-clock difference for dates and floating times (RFC 5545, section 3.8.5.3).
Duration from DTSTART to DTEND (or DUE): the exact elapsed time for UTC and zoned values,
the wall-clock difference for dates and floating times (RFC 5545, section 3.8.5.3).
|
#
|